/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.article.controller;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.community.agency.entity.Agency;
import org.springblade.community.agency.service.IAgencyService;
import org.springblade.community.residential.entity.Residential;
import org.springblade.community.residential.service.IResidentialService;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.estate.article.dto.AddCountDto;
import org.springblade.estate.ownerrecord.entity.OwnerRecord;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.estate.article.entity.Article;
import org.springblade.estate.article.vo.ArticleVO;
import org.springblade.estate.article.wrapper.ArticleWrapper;
import org.springblade.estate.article.service.IArticleService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.List;
import java.util.Map;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2020-12-22
 */
@RestController
@AllArgsConstructor
@RequestMapping("estate/article")
@Api(value = "CMS接口", tags = "CMS接口")
public class ArticleController extends BladeController {

	private IArticleService articleService;
	private IResidentialService residentialService;
	private IAgencyService agencyService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入article")
	public R<ArticleVO> detail(Article article) {
		Article detail = articleService.getOne(Condition.getQueryWrapper(article));
		return R.data(ArticleWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入article")
	public R<IPage<ArticleVO>> list(Article article, Query query, BladeUser bladeUser) {
		if (article.getAgencyId() != null){
			IPage<Article> pages = articleService.page(Condition.getPage(query), Condition.getQueryWrapper(article).eq("agency_id",article.getAgencyId()).orderByDesc("create_time"));
			return R.data(ArticleWrapper.build().pageVO(pages));
		}else if (bladeUser.getTenantId().equals("000000")){//超级管理员可以查看全部
			IPage<Article> pages = articleService.page(Condition.getPage(query), Condition.getQueryWrapper(article).orderByDesc("create_time"));
			return R.data(ArticleWrapper.build().pageVO(pages));
		}
		else {//根据tenantId查AgencyId，再根据AgencyId查询文章（一个tenantId绑定一个园区，可以直接添加tenantId字段，根据tenantId直接查文章）
			List<Agency> agencyList = agencyService.getBaseMapper().selectList(new QueryWrapper<>(new Agency()).eq("tenant_id",bladeUser.getTenantId()).eq("is_deleted",0));
			if (article.getTitle()!=null){
				IPage<Article> pages = articleService.page(Condition.getPage(query), new QueryWrapper<>(new Article()).eq("agency_id",agencyList.get(0).getId()).orderByDesc("create_time").like("title",article.getTitle()));
				return R.data(ArticleWrapper.build().pageVO(pages));
			}else {
				IPage<Article> pages = articleService.page(Condition.getPage(query), Condition.getQueryWrapper(article).eq("agency_id",agencyList.get(0).getId()).orderByDesc("create_time"));
				return R.data(ArticleWrapper.build().pageVO(pages));
			}
		}

//		LambdaQueryWrapper<Article> wrapper = Condition.getQueryWrapper(article,Article.class).lambda();
//		if (bladeUser.getTenantId().equals("000000")){
//			IPage<Article> pages = articleService.page(Condition.getPage(query),wrapper);
//			return R.data(ArticleWrapper.build().pageVO(pages));
//		}else {
//			List<Agency> agencyList = agencyService.getBaseMapper().selectList(new QueryWrapper<>(new Agency()).eq("tenant_id",bladeUser.getTenantId()).eq("is_deleted",0));
//			IPage<Article> pages = articleService.page(Condition.getPage(query), wrapper.eq(Article::getAgencyId, agencyList.get(0).getId()).orderByDesc(Article::getCreateTime));
//			return R.data(ArticleWrapper.build().pageVO(pages));
//		}
	}

	/**
	 * 阅读数+1
	 */
	@PostMapping("/addReaderCount")
	@ApiOperationSupport(order = 8)
	@ApiOperation(value = "增加阅读数", notes = "传入增加数量")
	public R addReaderCount(@RequestBody AddCountDto addCountDto) {
		try {
			articleService.addCount(addCountDto.getId(),addCountDto.getAddCount());
			return R.success("阅读数增加成功！");
		}catch (Exception e){
			return R.fail("增加失败！");
		}
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入article")
	public R<IPage<ArticleVO>> page(ArticleVO article, Query query) {
		IPage<ArticleVO> pages = articleService.selectArticlePage(Condition.getPage(query), article);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入article")
	public R save(@Valid @RequestBody Article article) {
		return R.status(articleService.save(article));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入article")
	public R update(@Valid @RequestBody Article article) {
		return R.status(articleService.updateById(article));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入article")
	public R submit(@Valid @RequestBody Article article, BladeUser bladeUser) {
		//园区CMS：一个账号对应一个tenant_id，使用selectOne
		List<Agency> agencyList = agencyService.getBaseMapper().selectList(new QueryWrapper<>(new Agency()).eq("tenant_id",bladeUser.getTenantId()).ne("is_deleted",1));
		article.setAgencyId(agencyList.get(0).getId());
		return R.status(articleService.saveOrUpdate(article));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(articleService.deleteLogic(Func.toLongList(ids)));
	}


}
